`timescale 1ns/1ps
module tm;

reg                     fclk = 0;
reg                     i3c_clk = 0;
reg                     rstn = 0;
reg                     psel = 0;
reg                     penable = 0;
reg                     pwrite = 0;
reg         [7:0]       paddr = 0;
reg         [31:0]      pwdat = 0;
wire        [31:0]      prdat;

wire                    SDA_PULL;
wire                    int_o;

initial begin
 #0.1 fclk = 1;
 forever #12.5 fclk = !fclk;
end

always #5 i3c_clk = !i3c_clk;

initial begin
    rstn = 0;
    #10000;
    rstn = 1;
end

pullup sda(SDA);
pullup scl(SCL);

reg [7:0]       addr_mcfg = 8'h00;
reg             mcfg_master_on = 1'b1;

reg [7:0]       addr_mis = 8'h90;

reg [7:0]       addr_mcontrol = 8'h84;
reg             mcontrol_write = 1'b0;
reg             mcontrol_read = 1'b1;
reg [1:0]       mcontrol_ack = 2'b0;
reg [1:0]       mcontrol_i3c = 2'h0;
reg [1:0]       mcontrol_ddr = 2'h2;
reg [2:0]       mcontrol_emitdaa = 3'h4;
reg [2:0]       mcontrol_emitstartandaddr = 3'h1;
reg [2:0]       mcontrol_emitstop = 3'h2;
reg [2:0]       mcontrol_emit_ddr_exit = 3'h6;

reg [7:0]       addr_msts = 8'h88;
reg [7:0]       addr_mtxb = 8'hB0;
reg [7:0]       addr_mrxb = 8'hC0;

reg             RESERVED = 1'd0;

initial begin
    wait(rstn == 1);
    $display("%tps:----------configure MCFG reg----------",$realtime);
    operation_write(addr_mcfg,{4'h4,{3{RESERVED}},1'b0,8'ha,4'h0,4'h3,RESERVED,RESERVED,{2{RESERVED}},1'b0,{2{RESERVED}},mcfg_master_on});
    $display("%tps:----------INT ENABLE----------",$realtime);
    operation_write(addr_mis,32'hffffffff);
    $display("%tps:----------DAA----------",$realtime);
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h12,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitdaa});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_write(addr_mtxb,{24'h0,{7'h32,1'b0}});       //write tx data to fifo
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h12,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitdaa});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------SDR WRITE----------",$realtime);
    operation_write(addr_mtxb,{24'h0,8'h34});       //write tx data to fifo 0X34
    operation_write(addr_mtxb,{24'h1,8'h56});      //write the last tx data to fifo 0X56
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h32,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitstartandaddr}); 
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------EMIT STOP----------",$realtime);
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h32,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitstop});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------SDR READ----------",$realtime);
    operation_write(addr_mtxb,{24'h1,8'h34});       //write tx data to fifo 0X34
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h32,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitstartandaddr});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h1,7'h32,mcontrol_read,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitstartandaddr});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------EMIT STOP----------",$realtime);
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h32,mcontrol_write,mcontrol_ack,mcontrol_i3c,RESERVED,mcontrol_emitstop});
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------ENTDDR + DDR WRITE----------",$realtime);
    operation_write(addr_mtxb,{24'h0,8'h10});       //write tx data to fifo 0X10
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h0,7'h32,mcontrol_write,mcontrol_ack,mcontrol_ddr,RESERVED,mcontrol_emitstartandaddr});    //EMITDDRRESTART 0x32
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_write(addr_mtxb,{24'h0,8'h34});       //write tx data to fifo 0X34
    operation_write(addr_mtxb,{24'h1,8'h56});      //write the last tx data to fifo 0X56
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------DDRRESTART + DDR READ----------",$realtime);
    operation_write(addr_mtxb,{24'h0,8'h80});       //write tx data to fifo 0X80
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h2,7'h32,mcontrol_write,mcontrol_ack,mcontrol_ddr,RESERVED,mcontrol_emitstartandaddr});    //EMITDDRRESTART 0x32
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_read(addr_mrxb);//read data from rcve fifo
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int
    $display("%tps:----------DDR EXIT----------",$realtime);
    operation_write(addr_mcontrol,{{8{RESERVED}},8'h2,7'h32,mcontrol_write,mcontrol_ack,mcontrol_ddr,RESERVED,mcontrol_emit_ddr_exit});    //EMITDDREXIT 0x34
    operation_read_status(addr_msts);       //read MSTATUS after int
    operation_write(addr_msts,32'hffffffff);//clear the int*/

end

I3C_Dual_Clock_Top i3c_dual_clock_top(
    .SCL                        (SCL),
    .SDA                        (SDA),
    .fclk                       (fclk),
    .rstn                       (rstn),
    .SDA_PULL                   (SDA_PULL),
    .PSEL                       (psel),
    .PENABLE                    (penable),
    .PWRITE                     (pwrite),
    .PADDR                      (paddr),
    .PWDATA                     (pwdat),
    .PRDATA                     (prdat),
    .int_o                      (int_o),
    .i3c_clk                    (i3c_clk)
);

ts u_ts(
    .SCL                        (SCL),
    .SDA                        (SDA)
);

task    operation_write;
    input           [7:0]       addr;
    input           [31:0]      wdata;
    begin
    @(posedge fclk);
    psel <= 1;
    pwrite <= 1;
    paddr <= addr;
    pwdat <= wdata;
    @(posedge fclk);
    psel <= 1;
    penable <= 1;
    pwrite <= 1;
    paddr <= addr;
    pwdat <= wdata;
    @(posedge fclk);
    psel <= 0;
    penable <= 0;
    pwrite <= 0;
    paddr <= 8'h00;
    pwdat <= 32'h00;
    end
endtask
task    operation_read_status;
    input           [7:0]       addr;
    begin
    @(negedge int_o);
    @(posedge fclk);
    psel <= 1;
    pwrite <= 0;
    paddr <= addr;
    @(posedge fclk);
    psel <= 1;
    penable <= 1;
    pwrite <= 0;
    paddr <= addr;
    @(posedge fclk);
    psel <= 0;
    penable <= 0;
    pwrite <= 0;
    paddr <= 8'h00;
    end
endtask
task    operation_read;
    input           [7:0]       addr;
    begin
    @(posedge fclk);
    psel <= 1;
    pwrite <= 0;
    paddr <= addr;
    @(posedge fclk);
    psel <= 1;
    penable <= 1;
    pwrite <= 0;
    paddr <= addr;
    @(posedge fclk);
    psel <= 0;
    penable <= 0;
    pwrite <= 0;
    paddr <= 8'h00;
    end
endtask


initial begin
    #400000;
    $stop;
end

initial begin
    $fsdbDumpfile("tb.fsdb");
    $fsdbDumpvars;
end

endmodule

